import threading
import time
from airtest.core.api import *
from selenium import webdriver
from selenium.webdriver import DesiredCapabilities
from selenium.webdriver.common.keys import Keys
from airtest_selenium.proxy import *
from selenium.webdriver import Chrome, ChromeOptions
from airtest.core.api import *
from airtest_selenium.proxy import *

def job():
    print("这是一个需要执行的任务。。。。。")
    create_salesorder()
    print("当前线程的个数:", threading.active_count())
    time.sleep(1)
    print("当前线程的信息:", threading.current_thread())


def create_salesorder():
    import time
    start = time.clock()
    # caps = DesiredCapabilities().CHROME
    # caps["pageLoadStrategy"] = "normal"  # complete
    # caps["pageLoadStrategy"] = "eager"  #  interactive
    # caps["pageLoadStrategy"] = "none"
    # chrome = webdriver.Chrome(desired_capabilities=caps)
    opt = ChromeOptions()  # 创建 Chrome 参数对象
    # opt.headless = True  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
    opt.headless = False  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
    opt.add_argument('--start-maximized')
    opt.add_argument('--window-size=1280x1024')
    # chrome = Chrome(options=opt) # 创建无界面对象
    # chrome = WebChrome(chrome_options=opt)
    chrome = WebChrome(chrome_options=opt)
    # chrome=webdriver.Chrome()
    chrome.implicitly_wait(20)
    # chrome.get("http://10.17.65.200:8088/portal/")
    chrome.get("http://10.17.65.207:8088/uat/r/w")
    sleep(2)
    chrome.implicitly_wait(30)
    chrome.maximize_window()
    chrome.find_element_by_id('input1').send_keys('admin')
    chrome.find_element_by_id('input2').send_keys('Gyxc1234')
    chrome.find_element_by_id('input2').send_keys(Keys.ENTER)
    while True:
        try:
            if(chrome.find_element_by_xpath('//span[text()="退出"]').is_displayed()==True):
                break
        except:
            continue

    chrome.find_element_by_xpath('//div[text()="销售管理"]').click()
    actions = ActionChains(chrome)
    actions.move_to_element(chrome.find_element_by_xpath('//div[text()="销售业务"]')).perform()
    chrome.find_element_by_xpath('//span[text()="销售订单"]').click()
    chrome.switch_to.frame(chrome.find_element_by_xpath('(//iframe[@class="metro-main-frame"])[2]'))

    chrome.find_element_by_xpath('//span[text()="新建"]').click()
    sleep(4)
    chrome.switch_to.frame(chrome.find_element_by_xpath('//iframe[contains(@name,"awsui-dialog-iframe")]'))

     # chrome.switch_to.default_content()
    sleep(4)
    # while True:
    #     try:
    #         if chrome.find_element_by_xpath('//div[text()="订单公司名称 "]').is_displayed():
    #             print(chrome.find_element_by_xpath('//div[text()="订单公司名称 "]').text)
    #             break
    #     except:
    #         continue
    print(chrome.find_element_by_xpath('//div[text()="订单公司名称 "]').text)


    sleep(2)
    chrome.find_element_by_xpath(
        '//div[text()="订单公司名称 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:公司名称,公司编码"]').send_keys('国药集团北京')
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:公司名称,公司编码"]').send_keys(Keys.ENTER)
    chrome.find_element_by_xpath('(//span[@class="el-radio__inner"])[1]').click()

    chrome.find_element_by_xpath('//span[@class="ensureBtn"]/button').click()
    chrome.find_element_by_xpath('//button[@class="el-button el-button--primary el-button--mini"]').click()
    chrome.find_element_by_xpath('//div[text()="出库仓库 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:仓库编码,仓库名称,是否传WMS,所属公司名称"]').send_keys('北京强生非')
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:仓库编码,仓库名称,是否传WMS,所属公司名称"]').send_keys(Keys.ENTER)
    # chrome.find_element_by_xpath('//span/input[@type="radio" and @value="03105272b49986351ef7eb2930b5454de"]').click()
    btn_div= chrome.find_element_by_xpath('//span/input[@type="radio" and @value="03105272b49986351ef7eb2930b5454de"]')
    chrome.execute_script("arguments[0].click();", btn_div)
    chrome.find_element_by_xpath('(//button[@class="el-button el-button--primary el-button--default"])[3]').click()
    chrome.find_element_by_xpath('//div[text()="客户及合同信息"]').click()
    chrome.find_element_by_xpath(
        '//div[text()="合同号 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:合同号,合同协议号,对方编码,项目名称,项目编码,业态编码,参考部门,参考部门编码,参考业务员,参考业务员编码,产品线名称,产品线编码,合同类型,合同属性"]').send_keys('40080')
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:合同号,合同协议号,对方编码,项目名称,项目编码,业态编码,参考部门,参考部门编码,参考业务员,参考业务员编码,产品线名称,产品线编码,合同类型,合同属性"]').send_keys(Keys.ENTER)
    chrome.find_element_by_xpath('//div[@class="multiple-header string_col" and text()="40080"]/ancestor-or-self::td/preceding-sibling::td/div/label/span/span').click()
    chrome.find_element_by_xpath('(//button[@class="el-button el-button--primary el-button--default"])[4]').click()
    #客户名称
    chrome.find_element_by_xpath(
        '//div[text()="客户名称 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:客户编码,客户名称,收货地址号,收货地址信息,公司编码,货币码,税率/税区,客户分类,联系人,联系人电话"]').send_keys('北京大学第三医院')
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:客户编码,客户名称,收货地址号,收货地址信息,公司编码,货币码,税率/税区,客户分类,联系人,联系人电话"]').send_keys(Keys.ENTER)
    chrome.find_element_by_xpath('(//div[text()="北京大学第三医院"])[3]/ancestor-or-self::td/preceding-sibling::td/div/label/span/span').click()
    chrome.find_element_by_xpath('(//span[@class="ensureBtn"]/button[1])[4]').click()
    # 业务员名称
    chrome.find_element_by_xpath(
        '//div[text()="业务员名称 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:业务员名称,业务员编码,业务部门名称,业务部门编码,部门类型编码"]').send_keys('杨春刚')
    chrome.find_element_by_xpath('//input[@placeholder="模糊检索:业务员名称,业务员编码,业务部门名称,业务部门编码,部门类型编码"]').send_keys(Keys.ENTER)
    chrome.find_element_by_xpath(
        '(//div[text()="杨春刚"])[3]/ancestor-or-self::td/preceding-sibling::td/div/label/span/span').click()
    chrome.find_element_by_xpath('(//span[@class="ensureBtn"]/button)[13]').click()
    #其他信息页签
    chrome.find_element_by_xpath('//div[text()="其他信息"]').click()
    chrome.find_element_by_xpath('//div[@cid="AWSUI.SwitchButton"]//div/div/div/div/span[1]').click()
    # 子表信息录入
    chrome.find_element_by_xpath('//div[text()="主体信息"]').click()
    chrome.find_element_by_xpath('//span[text()="添加商品"]').click()
    chrome.find_element_by_xpath(
        '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,主计量单位,销售计量单位,厂家物料编码,存储条件说明,生产企业编码,供应商编码,行类型,商品性质,批发价,进口/国产/港澳台,件包数,产品备注,是否免备案,产品描述"]').send_keys(
        '10006179')
    chrome.find_element_by_xpath(
        '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,主计量单位,销售计量单位,厂家物料编码,存储条件说明,生产企业编码,供应商编码,行类型,商品性质,批发价,进口/国产/港澳台,件包数,产品备注,是否免备案,产品描述"]').send_keys(
        Keys.ENTER)
    chrome.find_element_by_xpath('(//span[@class="el-checkbox__inner"])[4]').click()
    chrome.find_element_by_xpath('(//div[@class="el-dialog__body"]/div[2]/span/button[1]/span)[6]').click()
    sleep(10)
    element=chrome.find_element_by_xpath('//td[@colid="col_177"]')
    element.click()
    sleep(6)
    # element.send_keys("1")
    chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='1'");
    sleep(3)
    #滚动条右拉
    # document.getElementsByClassName('vxe-table--footer-wrapper body--wrapper')[0].scrollLeft = 5000
    chrome.execute_script("document.getElementsByClassName('vxe-table--footer-wrapper body--wrapper')[0].scrollLeft = 2000");
    element = chrome.find_element_by_xpath('//td[@colid="col_197"]')
    element.click()
    sleep(6)
    chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='8'");
    sleep(2)
    element = chrome.find_element_by_xpath('//td[@colid="col_198"]')
    element.click()
    sleep(6)
    chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='8'");
    sleep(2)
    chrome.find_element_by_xpath('//span[text()="提交"]').click()
    sleep(2)
    chrome.find_element_by_xpath('//button[@class="el-button el-button--primary el-button--mini awsui-button awsui-button--primary"]//span[text()="确定"]').click()
    chrome.switch_to.default_content()
    while True:
        try:
            if chrome.find_element_by_xpath('//span[text()="新建"]').is_displayed()==True:
                break
        except:
            continue
    print('销售订单创建完成')
    end = time.clock()
    print(start, end)
    print('CPU执行时间: ', end - start)
if __name__ == "__main__":
    # 创建多线程时， 需要制定该线程执行的任务.name线程名字 target目标函数名
    # t1 = threading.Thread(target=job,name="job1")
    # t2 = threading.Thread(target=job,name="job2")
    # t1.start()
    # t2.start()
    for i in range(1):
        t = threading.Thread(target=job)
        t.start()

    # print(threading.active_count())
    # print("程序执行结束.....")
    # create_salesorder()
