import datetime
import threading
import time
import traceback

from airtest.core.api import *
from selenium import webdriver
from selenium.webdriver import DesiredCapabilities
from selenium.webdriver.common.keys import Keys
from airtest_selenium.proxy import *
from selenium.webdriver import Chrome, ChromeOptions
from airtest.core.api import *
from airtest_selenium.proxy import *
from selenium.webdriver.support.select import Select

from mail1 import send_email1
from public.tools import *




# chrome = webdriver.Chrome(chrome_options=opt)

def job():
    print("这是一个需要执行的任务。。。。。")
    create_salesorder()
    print("当前线程的个数:", threading.active_count())
    time.sleep(1)
    print("当前线程的信息:", threading.current_thread())
def add_goods(goodsname,chrome):
    chrome.find_element_by_xpath(
        '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,采购计量单位,销售计量单位,生产厂家编码"]').send_keys(
        goodsname)
    chrome.find_element_by_xpath(
        '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,采购计量单位,销售计量单位,生产厂家编码"]').send_keys(
        Keys.ENTER)
    # 获取页数
    # pagecount=chrome.find_element_by_xpath('(// li[ @class ="number"])[16]').text
    pagecount = 10
    for i in range(int(pagecount)):
        sleep(1)
        chrome.find_element_by_xpath(
            '//th[@class="el-table_15_column_192 multiple-column el-table-column--selection is-leaf headerCellClassName el-table__cell"]/div/label/span/span').click()
        # 翻页
        chrome.find_element_by_xpath('(//button[@class="btn-next is-last"])[5]').click()


sleep(1)


#配货函数
def match_goods(chrome,orderno,type):
    chrome.switch_to.default_content()
    sleep(1)
    chrome.find_element_by_xpath('//span[@class="awsui-tabs-icon close"]').click()
    sleep(1)
    order_link = chrome.find_element_by_xpath('//span[text()="分配经销商要货"]')
    chrome.execute_script("arguments[0].click();", order_link)
    chrome.switch_to.frame(chrome.find_element_by_xpath('(//iframe[@class="metro-main-frame"])[2]'))
    sleep(2)
    chrome.switch_to.frame(chrome.find_element_by_xpath('//iframe[contains(@name,"awsui-dialog-iframe")]'))
    sleep(2)
    s = Select(chrome.find_element_by_id('purchasingCoOptSelect'))
    s.select_by_index(0)
    sleep(2)
    # chrome.find_element_by_xpath('//li[text()="北京大学第三医院(3)"]').click()
    # sleep(1)
    chrome.find_element_by_xpath('//span[text()="%s"]'%orderno).click()
    sleep(4)
    # 点击自动填充按钮
    chrome.find_element_by_xpath('//button[text()="自动填充"]').click()
    # sleep(4)
    while True:
        try:
            chrome.find_element_by_xpath('//button[text()="提交"]').click()
            break
        except:
            continue
    sleep(2)
    # chrome.find_element_by_xpath('//a[text()="确认"]').click()
    sleep(1)

    # 方案一============================开始
    if type == 1:
        import datetime
        now = datetime.datetime.now()
        one_minutes_later = now + datetime.timedelta(minutes=1)
        now = now.strftime('%Y-%m-%d %H:%M')
        one_minutes_later = one_minutes_later.strftime('%Y-%m-%d %H:%M')
        # print('bbbbbbbb'+one_minutes_later)
        while True:
            now = datetime.datetime.now().strftime('%Y-%m-%d %H:%M')
            # print('变化的时间' + now)
            if now == one_minutes_later:
                print('时间到了')
                start = time.clock()
                print('提交订单开始时间', start)
                chrome.find_element_by_xpath('//a[text()="确认"]').click()
                break
    # 方案一============================结束
    # 方案二===============开始
    if type == 2:
        m = get_time_m()  # 当前时间的分钟
        m1 = get_submit_time(m)  # 计划提交时间的分钟
        print('销售订单计划提交时间的分钟', m1)
        while True:
            m2 = get_time_m()  # 循环获取当前的分
            # sleep(30)
            if (m2 == m1):
                start = time.clock()
                chrome.find_element_by_xpath('//a[text()="确认"]').click()
                break
        # 方案二===============结束
    while True:
        try:
            if chrome.find_element_by_xpath('//div[text()="提交成功"]').is_displayed() == True:
                # print('订单完成了')
                break
            # else:
            #     print('共享任务创建成功的元素没有出现')
        except:
            continue
    end = time.clock()
    print(start, end)
    # print('CPU执行时间: ', end - start)
    return str(end - start)

def create_salesorder(type=1):
    try:
        import time
        pro_path = get_pro_path()
        start = time.clock()
        print('开始时间',start)
        # caps = DesiredCapabilities().CHROME
        # caps["pageLoadStrategy"] = "normal"  # complete
        # caps["pageLoadStrategy"] = "eager"  #  interactive
        # caps["pageLoadStrategy"] = "none"
        # chrome = webdriver.Chrome(desired_capabilities=caps)
        opt = ChromeOptions()  # 创建 Chrome 参数对象
        # opt.headless = True  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
        opt.headless = False  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
        opt.add_argument('--start-maximized')
        opt.add_argument('--window-size=1280x1024')
        # chrome = Chrome(options=opt) # 创建无界面对象
        # chrome = WebChrome(chrome_options=opt)
        chrome = WebChrome(chrome_options=opt)
        # chrome=webdriver.Chrome()
        chrome.implicitly_wait(20)
        chrome.get("http://10.17.65.200:8088/portal/")
        # chrome.get("http://10.17.65.207:8088/uat/r/w")
        sleep(2)
        chrome.implicitly_wait(30)
        # chrome.maximize_window()
        chrome.find_element_by_id('input1').clear()
        chrome.find_element_by_id('input1').send_keys('admin')
        chrome.find_element_by_id('input2').clear()
        chrome.find_element_by_id('input2').send_keys('Gyxc1234')
        chrome.find_element_by_id('input2').send_keys(Keys.ENTER)
        while True:
            try:
                if(chrome.find_element_by_xpath('//span[text()="退出"]').is_displayed()==True):
                    break
            except:
                continue
        #切换所属公司
        chrome.find_element_by_class_name('changeCom').click()
        sleep(1)
        chrome.find_element_by_xpath('//span[text()="国药集团北京医疗器械有限公司"]/following-sibling::button').click()
        sleep(1)
        chrome.find_element_by_xpath('// button[text() = "确定"]').click()
        sleep(1)
        order_link = chrome.find_element_by_xpath('//span[text()="经销商要货申请"]')
        chrome.execute_script("arguments[0].click();", order_link)
        chrome.switch_to.frame(chrome.find_element_by_xpath('(//iframe[@class="metro-main-frame"])[2]'))
        sleep(4)
        chrome.find_element_by_xpath('//span[text()="新建"]').click()
        sleep(4)
        chrome.switch_to.frame(chrome.find_element_by_xpath('//iframe[contains(@name,"awsui-dialog-iframe")]'))
        # 获取订单号

        orderno = chrome.find_element_by_xpath('//div[text() = "要货申请单号 "]/following-sibling::div/span').text
        print(orderno)
         # chrome.switch_to.default_content()
        sleep(4)
        # while True:
        #     try:
        #         if chrome.find_element_by_xpath('//div[text()="订单公司名称 "]').is_displayed():
        #             print(chrome.find_element_by_xpath('//div[text()="订单公司名称 "]').text)
        #             break
        #     except:
        #         continue
        print(chrome.find_element_by_xpath('//div[text()="要货申请单号 "]').text)


        sleep(2)
        #客户名称
        chrome.find_element_by_xpath(
            '//div[text()="客户名称 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:客户编码,客户名称,收货地址,产品线名称,产品线编码"]').send_keys('北京大学')
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:客户编码,客户名称,收货地址,产品线名称,产品线编码"]').send_keys(Keys.ENTER)
        chrome.find_element_by_xpath('(//span[@class="el-radio__inner"])[1]').click()

        chrome.find_element_by_xpath('//span[@class="ensureBtn"]/button').click()

        #详细信息
        chrome.find_element_by_xpath('//div[text()="详细信息"]').click()

        chrome.find_element_by_xpath('//div[text()="合同/协议号 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:合同协议号,合同号"]').send_keys('38443')
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:合同协议号,合同号"]').send_keys(Keys.ENTER)
        # chrome.find_element_by_xpath('//span/input[@type="radio" and @value="03105272b49986351ef7eb2930b5454de"]').click()
        btn_div= chrome.find_element_by_xpath('//span/input[@type="radio" and @value="012001f8d35054875d6157d4715404319"]')
        chrome.execute_script("arguments[0].click();", btn_div)
        chrome.find_element_by_xpath('(//button[@class="el-button el-button--primary el-button--default"])[3]').click()
        sleep(1)

         #业务员名称
        chrome.find_element_by_xpath(
            '//div[text()="业务员名称 "]/following-sibling::div/div/div/div/div/div/div/div/span/span/i').click()
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:业务员名称,业务员编码,业务部门名称,部门编码,部门类型编码"]').send_keys('chenshuheng')
        chrome.find_element_by_xpath('//input[@placeholder="模糊检索:业务员名称,业务员编码,业务部门名称,部门编码,部门类型编码"]').send_keys(Keys.ENTER)
        chrome.find_element_by_xpath('(//div[text()="chenshuheng"])[3]/ancestor-or-self::td/preceding-sibling::td/div/label/span/span').click()
        chrome.find_element_by_xpath('(//span[@class="ensureBtn"]/button[1])[3]').click()
        # #其他信息页签
        # chrome.find_element_by_xpath('//div[text()="其他信息"]').click()
        # chrome.find_element_by_xpath('//div[@cid="AWSUI.SwitchButton"]//div/div/div/div/span[1]').click()
        # 子表信息录入
        chrome.find_element_by_xpath('//div[text()="主体信息"]').click()
        # 点击添加商品弹出添加商品子窗口
        for i in range(1):
            chrome.find_element_by_xpath('//span[text()="添加商品"]').click()
            add_goods('PTCA', chrome)
            chrome.find_element_by_xpath('(//div[@class="el-dialog__body"]/div[2]/span/button[1]/span)[4]').click()
            sleep(20)
        # chrome.find_element_by_xpath('//span[text()="添加商品"]').click()
        # chrome.find_element_by_xpath(
        #     '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,采购计量单位,销售计量单位,生产厂家编码"]').send_keys(
        #     '10006179')
        # chrome.find_element_by_xpath(
        #     '//input[@placeholder="模糊检索:商品编码,商品名称,规格型号,采购计量单位,销售计量单位,生产厂家编码"]').send_keys(
        #     Keys.ENTER)
        # sleep(1)
        # chrome.find_element_by_xpath('(//span[@class="el-checkbox__inner"])[4]').click()
        # chrome.find_element_by_xpath('(//div[@class="el-dialog__body"]/div[2]/span/button[1]/span)[4]').click()
        while True:
            try:
                chrome.find_element_by_xpath('//div[@class="el-loading-spinner"]').is_displayed()
                continue
            except:
                break
        for i in range(1, 101):
            sleep(2)
            element=chrome.find_element_by_xpath('(//td[@colid="col_93"])[%s]'%i)
            element.click()
            sleep(2)
            # element.send_keys("1")
            # chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='1'")
            chrome.find_element_by_class_name('awsui-input-number-right').send_keys('1')
            # chrome.find_element_by_xpath('//td[@colid="col_177"]/div/div').send_keys('1')
            sleep(2)
            chrome.find_element_by_xpath('(//td[@colid="col_94"])[%s]'%i).click()
            sleep(2)
            chrome.execute_script(
                "document.getElementsByClassName('vxe-table--body-wrapper body--wrapper')[0].scrollTop = %s*50;" % i)
        # #滚动条右拉
        # # document.getElementsByClassName('vxe-table--footer-wrapper body--wrapper')[0].scrollLeft = 5000
        # chrome.execute_script("document.getElementsByClassName('vxe-table--footer-wrapper body--wrapper')[0].scrollLeft = 2000");
        # element = chrome.find_element_by_xpath('//td[@colid="col_197"]')
        # element.click()
        # sleep(2)
        # chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='8'")
        # sleep(2)
        # element = chrome.find_element_by_xpath('//td[@colid="col_198"]')
        # element.click()
        # sleep(2)
        # chrome.execute_script("document.getElementsByClassName('awsui-input-number-right')[0].value='8'")
        # sleep(2)
        # lock = threading.Lock()
        # lock.acquire()
        chrome.find_element_by_xpath('//span[text()="提交"]').click()

        while True:
            try:
                if chrome.find_element_by_xpath('//p[text()="共享任务创建成功"]').is_displayed()==True:
                    # print('订单完成了')
                    break
                # else:
                #     print('共享任务创建成功的元素没有出现')
            except:
                continue
        # lock.release()
        # sleep(2)
        # chrome.find_element_by_xpath('//button[@class="el-button el-button--primary el-button--mini awsui-button awsui-button--primary"]//span[text()="确定"]').click()
        # chrome.switch_to.default_content()
        # chrome.switch_to.frame(chrome.find_element_by_xpath('(//iframe[@class="metro-main-frame"])[2]'))
        # sleep(20)
        # while True:
        #     try:
        #         if chrome.find_element_by_xpath('//span[text()="%s"]' % orderno).is_displayed() == True:
        #             print('//span[text()="%s"]' % orderno)
        #             break
        #     except:
        #         continue
        while True:
            try:
                # if chrome.find_element_by_xpath('(//span[text()="%s"])[2]'%orderno).is_displayed()==True:
                if chrome.find_element_by_xpath(
                        '//span[text() = "1"]/ancestor-or-self::td/following-sibling::td/div/span').is_displayed() == True:
                    # print('aaaaaaaaaaaaaaaaaaaaaaaa', chrome.find_element_by_xpath(
                    #     '//span[text() = "1"]/ancestor-or-self::td/following-sibling::td/div/span').text)
                    break
            except:
                continue
        print('经销售要货申请单创建完成')
        # 审批
        chrome.switch_to.default_content()
        chrome.switch_to.frame(chrome.find_element_by_xpath('(//iframe[@class="metro-main-frame"])[2]'))
        sleep(2)
        chrome.find_element_by_xpath(
            '//span[text() = "%s"]' % orderno).click()
        chrome.switch_to.frame(chrome.find_element_by_xpath('//iframe[contains(@name,"awsui-dialog-iframe")]'))

        chrome.find_element_by_xpath('//span[text()="审核通过"]').click()
        sleep(1)
        chrome.find_element_by_xpath('//textarea[@placeholder="意见留言"]').send_keys('3333')
        sleep(1)
        chrome.find_element_by_xpath('//span[text()="发送"]').click()
        while True:
            try:
                if chrome.find_element_by_xpath('//p[text()="共享任务创建成功"]').is_displayed() == True:
                    # print('订单完成了')
                    break
                # else:
                #     print('共享任务创建成功的元素没有出现')
            except:
                continue
        time1=match_goods(chrome, orderno,type)
        # end = time.clock()
        # print(start, end)
        print('CPU执行时间: ', time1)
        imgInfo = getErrorPhoto(chrome)
        imgName = imgInfo[0]
        image_path = imgInfo[1]
        info=orderno+'执行耗时'+time1
        now = get_time()
        writeFile_append(pro_path + '/logs/catalina.out', info)
        send_email1(image_path, info)
    except Exception as e:
        print('出现异常')
        # 将日志写入到文件中单独存储
        pro_path = get_pro_path()
        traceback.print_exc()
        imgInfo = getErrorPhoto(chrome)
        imgName = imgInfo[0]
        image_path = imgInfo[1]
        print(imgName, image_path)
        print(repr(e))
        info = repr(e)
        now = get_time()
        writeFile_append(pro_path + '/logs/logerror%s.txt' % now, info)
        # send_email1(image_path, info)
if __name__ == "__main__":
    # 创建多线程时， 需要制定该线程执行的任务.name线程名字 target目标函数名
    # t1 = threading.Thread(target=job,name="job1")
    # t2 = threading.Thread(target=job,name="job2")
    # t1.start()
    # t2.start()
    # opt = ChromeOptions()  # 创建 Chrome 参数对象
    # # opt.headless = True  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
    # opt.headless = False  # 把 Chrome 设置成无界面模式，windows/Linux 皆可
    # opt.add_argument('--start-maximized')
    # opt.add_argument('--window-size=1280x1024')
    # # chrome = Chrome(options=opt) # 创建无界面对象
    # chrome = WebChrome(chrome_options=opt)  # airtest中的类

    count=1
    for i in range(count):
        t = threading.Thread(target=job)
        t.start()
    t.join()

def start1():
    count = 1
    for i in range(count):
        t = threading.Thread(target=job)
        t.start()
    t.join()

    # print(threading.active_count())
    # print("程序执行结束.....")
    # create_salesorder()
